from domainNetworkSelectionAdapter import DomainNetworkSelectionAdapter
import torchvision.models as models


class DomainNetworkSelection(DomainNetworkSelectionAdapter):
    def __init__(self, arguments):
        DomainNetworkSelectionAdapter.__init__(self, arguments)

    def SelectNetworkAndDataset(self):
        """ Select the Closest Network and Dataset for the Task

        Available Resources:
            self.target_dataset
            self.whitelist_datasets

        Returns: Nearest Network, Nearest Dataset

        """
        pretrained_network = models.resnet18(pretrained=True)
        if 'imagenet_1k_train' in self.whitelist_datasets:
            dataset = self.whitelist_datasets['mnist_train']
        else:
            random_dataset = list(self.whitelist_datasets.keys())[0]
            dataset = self.whitelist_datasets[random_dataset]
        return pretrained_network, dataset
